<?php
require 'vendor/autoload.php';
\Stripe\Stripe::setApiKey('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'); // clave secreta de Stripe

// Archivo JSON donde se guardarán los pagos procesados
$json_file = __DIR__ . "/procesados.json";
$procesados = file_exists($json_file) ? json_decode(file_get_contents($json_file), true) : [];

//https://chatgpt.com/c/67c691cc-09ac-8006-b461-6fa029caec6b
$email_a_buscar = "sav@savclicks.com"; // Reemplaza con el email que quieres filtrar
$email_destino = "destino@example.com"; // Reemplaza con el email que recibirá el pago
$monto_a_transferir = 500; // 5 CAD en centavos
$moneda = "cad";

// Obtener los últimos 5 pagos
$pagos = \Stripe\PaymentIntent::all(['limit' => 5]);
echo "<h2>Últimos 5 pagos recibidos:</h2>";
foreach ($pagos->data as $pago) {
    $id_pago = $pago->id;
    $email = $pago->receipt_email ?? "No disponible";
    $monto = number_format($pago->amount / 100, 2) . " " . strtoupper($pago->currency);
    $fecha = date("Y-m-d H:i:s", $pago->created);

    echo "<strong>Fecha:</strong> $fecha<br>";
    echo "<strong>ID Pago:</strong> $id_pago<br>";
    echo "<strong>Email:</strong> $email<br>";
    echo "<strong>Monto:</strong> $monto<br><hr>";
}

foreach ($pagos->data as $pago) {
    $pago_id = $pago->id;

    // Verificar si el pago ya fue procesado
    if (isset($procesados[$pago_id])) {
        echo "<h3>El pago $pago_id ya fue procesado el {$procesados[$pago_id]}.</h3><hr>";
        continue;
    }

    // Verificar si el pago tiene un email registrado
    if (!empty($pago->receipt_email) && strtolower($pago->receipt_email) === strtolower($email_a_buscar)) {
        echo "<h3>¡Coincidencia encontrada!</h3>";
        echo "<p>Pago de '$email_a_buscar' encontrado:</p>";
        echo "<pre>" . json_encode($pago, JSON_PRETTY_PRINT) . "</pre>";

        // Crear un nuevo pago de 5 CAD al email destino
        $nuevo_pago = [
            "amount" => $monto_a_transferir,
            "currency" => $moneda,
            "payment_method_types" => ["card"],
            "receipt_email" => $email_destino,
            "description" => "Pago automático basado en ingreso de $email_a_buscar",
        ];

        echo "<h3>Datos del pago a crear:</h3>";
        echo "<pre>" . json_encode($nuevo_pago, JSON_PRETTY_PRINT) . "</pre>";

        // Si quieres hacer la transacción real, descomenta esto:
        try {
            echo "<h3>Pago creado exitosamente:</h3>";
            //$payment_intent = \Stripe\PaymentIntent::create($nuevo_pago);
            //echo "<pre>" . json_encode($payment_intent, JSON_PRETTY_PRINT) . "</pre>";

            // Guardar el pago procesado en el JSON
            $procesados[$pago_id] = date('Y-m-d H:i:s');
            file_put_contents($json_file, json_encode($procesados, JSON_PRETTY_PRINT));
        } catch (\Stripe\Exception\ApiErrorException $e) {
            echo "<h3>Error al crear el pago:</h3>";
            //echo "<pre>" . json_encode($e->getMessage(), JSON_PRETTY_PRINT) . "</pre>";
        }

        break; // Detener después de la primera coincidencia
    }
}
?>